## libmesh 0.7.1

=== libmesh/Makefile ===
# $Id: Makefile 4398 2011-04-22 18:13:16Z roystgnr $
#
# This is the Makefile for the libMesh library and helper
# applications.  This file is specific to the project.
# See the file Make.common for path configurations.
# Make.common is what should be included by applications
# using the library.

# Build the library and all utility applications by default:

default: all

# include the library options determined by configure
# (now included indirectly in Makefile.const - don't want to
# accidentally double-up on += variable modifications
# include Make.common

###############################################################################
include Makefile.const


###############################################################################
# Target:
#
target := $(mesh_library)

library: $(mesh_library)

all:: $(target) $(appbinfiles)

###############################################################################

#
# 
#
.PHONY: all clean clobber default distclean library target \
	doc upload doc_upload log cvsweb TODO svnexpand examples

#
# static library
#
ifeq ($(findstring darwin,$(hostos)),darwin)
$(mesh_library_dir)/libmesh$(static_libext): $(objects)
	@$(shell mkdir -p $(mesh_library_dir))
	@echo "Linking "$@
	@libtool -static -o $(mesh_library) $(objects)
	@$(MAKE) -C contrib

else
$(mesh_library_dir)/libmesh$(static_libext): $(objects)
	@$(shell mkdir -p $(mesh_library_dir))
	@echo "Linking "$@
	@$(AR) rv $(mesh_library) $(objects)
	@$(MAKE) -C contrib
endif
# shared library
#
$(mesh_library_dir)/libmesh$(shared_libext): $(objects)
	@$(shell mkdir -p $(mesh_library_dir))
	@echo "Linking "$@
	@$(libmesh_CXX) $(libmesh_CXXSHAREDFLAG) -o $(mesh_library) $(objects) $(libmesh_LDFLAGS)
	@$(MAKE) -C contrib

#
# Build just object files
#
obj: $(objects)

#
# Build the examples.  Can be run in parallel with "make -jN examples"
#
examples: $(mesh_library)
	@$(MAKE) -C examples

# Only link the examples.  Deprecated, use "make examples" instead.
#
# link_examples: $(mesh_library)
# 	@$(MAKE) -C examples link

#
# Run the examples
#
run_examples: $(mesh_library)
	@$(MAKE) -C examples run

#
# Clean the examples
#
clean_examples:
	@$(MAKE) -C examples clean

#
# Test the header files to make sure they all compile stand-alone
# Also a cheat here: removing an ex-configure-output so it isn't
# detected as an invalid header for people without fresh checkouts
#
test_headers:
	@rm -f include/base/libmesh_contrib_config.h
	@cd contrib/bin && ./test_headers.sh

#	
# Remove object files for the current mode
#
clean:
	@test ! -d contrib || $(MAKE) -C contrib $(MAKECMDGOALS)
	@test ! -d examples || $(MAKE) -C examples $(MAKECMDGOALS)
	@rm -f *~ include/*~ include/*/*~ src/*/*~ src/*/*.$(obj-suffix) doc/html/*~

#
# Make clean, remove all binaries and generated files.  Leaves libraries in-tact
#
clobber:
	@$(MAKE) clean
	@test ! -d contrib || $(MAKE) -C contrib $(MAKECMDGOALS)
	@test ! -d examples || $(MAKE) -C examples $(MAKECMDGOALS)
	@rm -rf config.status $(targ_dir) $(appbinfiles)

#
# Make clobber, remove documentation, removes all libraries & object files for all modes
# Should restore to a pristine state, except for files you
# have added
distclean:
	@rm -f src/*/*.$(hosttype).*.o
	@$(MAKE) clobber
	@test ! -d contrib || $(MAKE) -C contrib $(MAKECMDGOALS)
	@test ! -d examples || $(MAKE) -C examples $(MAKECMDGOALS)
	@rm -rf doc/man/man3
	@rm -rf doc/html/doxygen/*.html # split these up, otherwise command line gets too long
	@rm -rf doc/html/doxygen/*.php
	@rm -rf doc/html/doxygen/*.png
	@rm -rf doc/html/doxygen/*.gif
	@rm -rf doc/html/doxygen/*.map
	@rm -rf doc/html/doxygen/*.md5
	@rm -rf doc/html/doxygen/*.dot
	@rm -rf doc/html/doxygen/formula.repository doc/html/doxygen/graph_legend.dot
	@rm -rf doc/latex/doxygen
	@rm -rf doc/latex/*/*.aux doc/latex/*/*~ doc/latex/*/*.log doc/latex/*/*.out
	@rm -rf src/*/*.o
	@rm -rf lib/*_opt lib/*_dbg lib/*_pro lib/*_devel lib/*_oprof



#
# all documentation
#
doc: doxygen_doc examples_doc

#
# doxygen documentation
#
doxygen_doc:
	$(doxygen) ./doc/Doxyfile
	@rm -rf doc/html/doxygen/*.map
	@rm -rf doc/html/doxygen/*.md5
	@rm -rf doc/html/doxygen/*.dot
	@rm -rf doc/html/doxygen/formula.repository

#
# examples documentation
#
examples_doc:
	contrib/bin/create_example_docs.sh

#
# Upload the web page to sourceforge.  We need a way to specify usernames
# other than $USER when connecting to sourceforge servers... Please set the
# environment variable: $LIBMESH_SVN_USER if your sourceforge username
# is different than whatever $USER is.
#
ifeq (x$(LIBMESH_SVN_USER),x) #unset
  upload_name=$(USER),libmesh@
else
  upload_name=$(LIBMESH_SVN_USER),libmesh@
endif

upload:
	chmod -R g+w ./doc/html/* ./doc/latex/*/*
	rsync -rltzve ssh --exclude '.svn' ./doc/html/ $(upload_name)web.sourceforge.net:/home/groups/l/li/libmesh/htdocs
	rsync -rltzve ssh --exclude '.svn' ./doc/latex/howto $(upload_name)web.sourceforge.net:/home/groups/l/li/libmesh/htdocs/
	rsync -rltzve ssh --exclude '.svn' ./doc/latex/xda_format $(upload_name)web.sourceforge.net:/home/groups/l/li/libmesh/htdocs/
	chmod -R g-w ./doc/html/* ./doc/latex/*/*


#
# Test Uploading (rsync -n) the web page to sourceforge.  Try this
# if you want to see what *would be* uploaded with a real rsync.
#
upload_test:
	chmod -R g+w ./doc/html/* ./doc/latex/*/*
	rsync -nrltzve ssh --exclude '.svn' ./doc/html/ $(upload_name)libmesh.sourceforge.net:/home/groups/l/li/libmesh/htdocs
	rsync -nrltzve ssh --exclude '.svn' ./doc/latex/howto $(upload_name)libmesh.sourceforge.net:/home/groups/l/li/libmesh/htdocs/
	rsync -nrltzve ssh --exclude '.svn' ./doc/latex/xda_format $(upload_name)libmesh.sourceforge.net:/home/groups/l/li/libmesh/htdocs/
	chmod -R g-w ./doc/html/* ./doc/latex/*/*


#
# Build and upload the documentation to sourceforge
#
doc_upload:
	@$(MAKE) doc
	@$(MAKE) upload


log: $(loggedfiles)
	cvs log $(loggedfiles) > cvs_log

#
# Web-based CVS documentation
# Please note: SourceForge provides a nice web interface to the CVS
# logs for the library.  You probably shouldn't need this target for
# anything.
cvsweb:
	./contrib/bin/cvs2html -f -p -o doc/cvshtml/index.html -v -a -b -n 2 -C crono.html

svnexpand:
        svn propset svn:keywords "Date Author Revision HeadURL Id" $(srcfiles) $(headerfiles) m4/*.m4

#
# Standalone applications.  Anything in the ./src/apps directory that ends in .C
# can be compiled with this rule.  For example, if ./src/apps/foo.C contains a main()
# and is a standalone program, then make bin/foo will work.
#
bin/%$(bin-suffix) : src/apps/%.$(obj-suffix) $(mesh_library)
	@echo "Linking $@"
	@$(libmesh_CXX) $(libmesh_CPPFLAGS) $(libmesh_CXXFLAGS) $(patsubst %.C,%.$(obj-suffix),$<) -o $@ $(libmesh_LIBS) $(libmesh_DLFLAGS) $(libmesh_LDFLAGS)

src/apps/%.$(obj-suffix) : src/apps/%.C
	@echo "Building $@"
	@$(libmesh_CXX) $(libmesh_CPPFLAGS) $(libmesh_CXXFLAGS) $(libmesh_INCLUDE) -c $< -o $(patsubst %.C,%.$(obj-suffix),$<) 

#
# In the contrib/bin directory, we run the test_headers.sh shell
# script.  This is a make rule for those tests.
#
contrib/bin/%.o : contrib/bin/%.C
	$(libmesh_CXX) $(libmesh_CPPFLAGS) $(libmesh_CXXFLAGS) $(libmesh_INCLUDE) -c $< -o $@

#
# Make a TODO list
#
TODO:
	@egrep -i '// *todo' $(srcfiles) $(headerfiles) \
	| perl -pi -e 's#(.*)(TODO:?)(\[.+\])#\3 \1\2\3#i;' \
	| perl -pi -e 's#\s*//\s*TODO:\s*(\[.+\])\s*#\n\1     #i;'



#
# Dependencies
#
.depend:
	@$(perl) ./contrib/bin/make_dependencies.pl $(foreach i, $(wildcard include/*), -I./$(i)) "-S\$$(obj-suffix)" $(srcfiles) $(appsrcfiles) > .depend



#
# Special rules for building some source files.  Must be *after* the 'all' target.
#

# This rule suppresses deprecated header warnings when compiling files with
# VTK headers.
src/mesh/vtk_io.$(obj-suffix) : src/mesh/vtk_io.C
	@echo "Compiling using special rule for vtk_io.C (in "$(mode)" mode) "$<"..."
	@$(libmesh_CXX) -Wno-deprecated $(libmesh_CPPFLAGS) $(libmesh_CXXFLAGS) $(libmesh_INCLUDE) -c $< -o $@




###############################################################################
include .depend


# Local Variables:
# mode: makefile
# End:

=== libmesh_tests/Makefile ===
LIBMESH_DIR ?= ..

CXX=$(shell ${LIBMESH_DIR}/contrib/bin/libmesh-config --cxx)
CFLAGS=-c -Wall $(shell ${LIBMESH_DIR}/contrib/bin/libmesh-config --cxxflags --include$) -I${CPP_UNIT}/include
LDFLAGS=-L${CPP_UNIT}/lib -lcppunit $(shell ${LIBMESH_DIR}/contrib/bin/libmesh-config --ldflags)
SOURCES=$(shell find ./ -name "*.C")
OBJECTS=$(SOURCES:.C=.o)
EXECUTABLE=run_tests

all: $(EXECUTABLE)
	$(LIBMESH_RUN) ./$(EXECUTABLE) $(LIBMESH_OPTIONS)
	
$(EXECUTABLE): depend $(SOURCES) $(OBJECTS)
	$(CXX) $(LDFLAGS) $(OBJECTS) -o $@

.C.o:
	$(CXX) $(CFLAGS) $< -o $@

clean:
	rm -rf *~* */*~* *.o */*.o run_tests .depends

depend: $(SOURCES)
	touch .depends
	@$(CXX) $(CFLAGS) -M $(SOURCES) > .depends

-include .depends
# DO NOT DELETE

=== libmesh/contrib/Makefile ===
#
# How to make the dependencies
#
all:
	@echo "----------------------------------------------"
	@echo "------- Building Contributed Packages --------"
	@echo "----------------------------------------------"
	@echo ""
	@echo "--- Building LASPACK -------------------------"
	@$(MAKE) -C laspack      $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building Metis ---------------------------"
	@$(MAKE) -C metis/Lib    $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building Parmetis ------------------------"
	@$(MAKE) -C parmetis/Lib $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building sfcurves ------------------------"
	@$(MAKE) -C sfcurves     $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building libgzstream ---------------------"
	@$(MAKE) -C gzstream     $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building TetGen ---------------------"
	@$(MAKE) -C tetgen       $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building triangle ---------------------"
	@$(MAKE) -C triangle     $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building gmv ---------------------"
	@$(MAKE) -C gmv          $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building netCDF ---------------------"
	@$(MAKE) -C netcdf/Lib   $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building ExodusII ---------------------"
	@$(MAKE) -C exodusii/Lib/src $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building Nemesis ---------------------"
	@$(MAKE) -C nemesis/Lib $(MAKECMDGOALS)
	@echo ""
	@echo "--- Building libHilbert ---------------------"
	@$(MAKE) -C libHilbert $(MAKECMDGOALS)
	@echo ""
	@echo "----------------------------------------------"
	@echo "----- Done Building Contributed Packages -----"
	@echo "----------------------------------------------"



#
# How to clean the packages
#
clean:
	@rm -f *~
	@$(MAKE) -C laspack      $(MAKECMDGOALS)
	@$(MAKE) -C metis/Lib    $(MAKECMDGOALS)
	@$(MAKE) -C parmetis/Lib $(MAKECMDGOALS)
	@$(MAKE) -C sfcurves     $(MAKECMDGOALS)
	@$(MAKE) -C gzstream     $(MAKECMDGOALS)
	@$(MAKE) -C tetgen       $(MAKECMDGOALS)
	@$(MAKE) -C triangle     $(MAKECMDGOALS)
	@$(MAKE) -C gmv          $(MAKECMDGOALS)
	@$(MAKE) -C netcdf/Lib   $(MAKECMDGOALS)
	@$(MAKE) -C exodusii/Lib/src $(MAKECMDGOALS)
	@$(MAKE) -C nemesis/Lib  $(MAKECMDGOALS)
	@$(MAKE) -C libHilbert   $(MAKECMDGOALS)

#
# How to clobber the packages
#
clobber:
	@$(MAKE) clean
	@$(MAKE) -C laspack      $(MAKECMDGOALS)
	@$(MAKE) -C metis/Lib    $(MAKECMDGOALS)
	@$(MAKE) -C parmetis/Lib $(MAKECMDGOALS)
	@$(MAKE) -C sfcurves     $(MAKECMDGOALS)
	@$(MAKE) -C gzstream     $(MAKECMDGOALS)
	@$(MAKE) -C tetgen       $(MAKECMDGOALS)
	@$(MAKE) -C triangle     $(MAKECMDGOALS)
	@$(MAKE) -C gmv          $(MAKECMDGOALS)
	@$(MAKE) -C netcdf/Lib   $(MAKECMDGOALS)
	@$(MAKE) -C exodusii/Lib/src $(MAKECMDGOALS)
	@$(MAKE) -C nemesis/Lib   $(MAKECMDGOALS)
	@$(MAKE) -C libHilbert   $(MAKECMDGOALS)

#
# How to distclean the packages
#
distclean:
	@$(MAKE) clobber
	@$(MAKE) -C laspack      $(MAKECMDGOALS)
	@$(MAKE) -C metis/Lib    $(MAKECMDGOALS)
	@$(MAKE) -C parmetis/Lib $(MAKECMDGOALS)
	@$(MAKE) -C sfcurves     $(MAKECMDGOALS)
	@$(MAKE) -C gzstream     $(MAKECMDGOALS)
	@$(MAKE) -C tetgen       $(MAKECMDGOALS)
	@$(MAKE) -C triangle     $(MAKECMDGOALS)
	@$(MAKE) -C gmv          $(MAKECMDGOALS)
	@$(MAKE) -C netcdf/Lib   $(MAKECMDGOALS)
	@$(MAKE) -C exodusii/Lib/src $(MAKECMDGOALS)
	@$(MAKE) -C nemesis/Lib   $(MAKECMDGOALS)
	@$(MAKE) -C libHilbert   $(MAKECMDGOALS)
	@rm -rf lib/*_dbg lib/*_opt lib/*_prof lib/*_oprof lib/*_devel

=== libmesh/examples/Makefile ===
# $Id: Makefile 4265 2011-03-15 14:07:08Z jwpeterson $

# The location of the mesh library
LIBMESH_DIR ?= ..

# Include the library options determined by configure.  This gives
# us access to the $(METHOD) variable for building the examples.
include $(LIBMESH_DIR)/Make.common

all:: examples

dirlist := $(wildcard ex?/ ex??/)
exec_names := $(patsubst %/, %-$(METHOD), $(dirlist))


# Build the example programs.  This target has been deprecated
# in favor of one that make can parallelize.
# examples:
# 	@echo "----------------------------------------------"
# 	@echo "--------- Building Example Programs ----------"
# 	@echo "----------------------------------------------"
# 	@for dir in $(dirlist); do $(MAKE) -C "$${dir}" $(MAKECMDGOALS)||exit 1; done
# 	@echo "----------------------------------------------"
# 	@echo "------- Done Building Example Programs -------"
# 	@echo "----------------------------------------------"


# This target allows the examples to be compiled in parallel
examples: $(exec_names)

# We could pass $(MAKECMDGOALS) here instead of "all" but then calling "make examples"
# in this directory doesn't work...
ex%-$(METHOD):
	$(MAKE) -C $(patsubst ex%-$(METHOD), ex%, $@) all||exit 1


.PHONY: clean clobber distclean link run .depend

#
# Clean up the example programs
clean:
	@for dir in $(dirlist); do $(MAKE) -C "$${dir}" $(MAKECMDGOALS)||exit 1; done

#
# Really clean up the example programs
clobber:
	@for dir in $(dirlist); do $(MAKE) -C "$${dir}" $(MAKECMDGOALS)||exit 1; done

# Make the example program directories look
# like a clean distribution
distclean:
	@for dir in $(dirlist); do $(MAKE) -C "$${dir}" $(MAKECMDGOALS)||exit 1; done

# Link the example programs (deprecated, use "make examples" instead)
# link: $(wildcard examples/ex*/*.C)
# 	@for dir in $(dirlist); do $(MAKE) -C "$${dir}" all||exit 1; done

#
# Run the example programs to see if shared lib's get properly loaded.
# This target should actually be "serialized" in the sense of 'make', we don't
# want all the examples to try and run simultaneously!
run: $(wildcard examples/ex*/*.C)
	@for dir in $(dirlist); do $(MAKE) -C "$${dir}" $(MAKECMDGOALS)||exit 1; done

#
# Rebuild the dependencies for the examples
.depend: $(wildcard examples/ex*/*.C)
	@for dir in $(dirlist); do $(MAKE) -C "$${dir}" $(MAKECMDGOALS)||exit 1; done

echo:
	@echo "dirlist = $(dirlist)"
	@echo "exec_names = $(exec_names)"

=== libmesh/contrib/gzstream/Makefile ===
# ============================================================================
# gzstream, C++ iostream classes wrapping the zlib compression library.
# Copyright (C) 2001  Deepak Bandyopadhyay, Lutz Kettner
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# ============================================================================
# 
# File          : Makefile
# Revision      : $Revision: 1.9 $
# Revision_date : $Date: 2007-09-07 21:55:47 $
# Author(s)     : Deepak Bandyopadhyay, Lutz Kettner
# 
# ============================================================================

# ----------------------------------------------------------------------------
# adapt these settings to your need:
# add '-DGZSTREAM_NAMESPACE=name' to CPPFLAGS to place the classes
# in its own namespace. Note, this macro needs to be set while creating
# the library as well while compiling applications based on it.
# As an alternative, gzstream.C and gzstream.h can be edited.
# ----------------------------------------------------------------------------



# The preceeding text came from the authors of this package.  The
# following allows it to link properly with our libraries.
include ../../Make.common

INCLUDES = -I.
SRC     := $(wildcard *.C)
OBJS   	:= $(patsubst %.C, %.$(obj-suffix), $(SRC))

library_name := libgzstream



#
# The remaining lines will usually work with any simple
# contributed project.  For example sfcurves follows the
# same procedure.
#
target       := $(EXTERNAL_LIBDIR)/$(library_name)$(static_libext)


ifeq ($(enable-shared),yes)	
  target := $(EXTERNAL_LIBDIR)/$(library_name)$(shared_libext)
endif

ifeq ($(enable-gzstream),no)
  # Do nothing
  all::
	@echo "<<< libgzstream is disabled, not building >>>"

else

all:: $(target)
ifeq ($(findstring darwin,$(hostos)),darwin)
$(EXTERNAL_LIBDIR)/$(library_name)$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@libtool -static -o $@ $(OBJS)
else
$(EXTERNAL_LIBDIR)/$(library_name)$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(AR) rv $@ $(OBJS)
endif

$(EXTERNAL_LIBDIR)/$(library_name)$(shared_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(libmesh_CXX) $(libmesh_CXXSHAREDFLAG) -o $@ $(OBJS) $(libmesh_LDFLAGS) -lz

endif

.PHONY: clean clobber distclean



clean:
	@rm -f $(OBJS) *~

clobber:
	@$(MAKE) clean
	@rm -f *.o *.g.o *.pg.o *.sy.o
	@rm -f $(EXTERNAL_LIBDIR)/$(library_name).*

distclean:
	@$(MAKE) clobber
	@rm -f ../lib/*/$(library_name).*

=== libmesh/contrib/laspack/Makefile ===
#
# let Make.common know that we are the Laspack
# Makefile, so that it can decide which compilation
# rules to tell
#
included-from-laspack := yes

include ../../Make.common

libmesh_INCLUDES = -I.

SRC     := $(wildcard *.c)
OBJS   	:= $(patsubst %.c, %.$(obj-suffix), $(SRC))



target := $(EXTERNAL_LIBDIR)/liblaspack$(static_libext)

ifeq ($(enable-shared),yes)
  target := $(EXTERNAL_LIBDIR)/liblaspack$(shared_libext)
endif


ifeq ($(enable-laspack),no)
  all::
	@echo "<<< laspack is disabled, not building >>>"
else
  all:: $(target)
endif

ifeq ($(findstring darwin,$(hostos)),darwin)
$(EXTERNAL_LIBDIR)/liblaspack$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@libtool -static -o $@ $(OBJS)
else
$(EXTERNAL_LIBDIR)/liblaspack$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(AR) rv $@ $(OBJS)
endif

ifeq ($(enable-complex),yes)
#
# Complex arithmetic: use C++ 
#
$(EXTERNAL_LIBDIR)/liblaspack$(shared_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(libmesh_CXX) $(libmesh_CXXSHAREDFLAG) -o $@ $(OBJS) $(libmesh_LDFLAGS)

else
#
# Real arithmetic: use C
#
$(EXTERNAL_LIBDIR)/liblaspack$(shared_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(libmesh_CC) $(libmesh_CSHAREDFLAG) -o $@ $(OBJS) $(libmesh_LDFLAGS)

endif


.PHONY: clean clobber distclean



clean:
	@rm -f $(OBJS) *~

clobber:
	@$(MAKE) clean
	@rm -f *.o *.g.o *.pg.o *.sy.o
	@rm -f $(EXTERNAL_LIBDIR)/liblaspack.*

distclean:
	@$(MAKE) clobber
	@rm -f ../lib/*/liblaspack.*

=== libmesh/contrib/sfcurves/Makefile ===
include ../../Make.common

INCLUDES = -I.

SRC     := $(wildcard *.c)
OBJS   	:= $(patsubst %.c, %.$(obj-suffix), $(SRC))



target := $(EXTERNAL_LIBDIR)/libsfcurves$(static_libext)

ifeq ($(enable-shared),yes)
  target := $(EXTERNAL_LIBDIR)/libsfcurves$(shared_libext)
endif


ifeq ($(enable-sfcurves),no)
  all::
	@echo "<<< sfcurves is disabled, not building >>>"
else
  all:: $(target)
endif

ifeq ($(findstring darwin,$(hostos)),darwin)
$(EXTERNAL_LIBDIR)/libsfcurves$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@libtool -static -o $@ $(OBJS)
else
$(EXTERNAL_LIBDIR)/libsfcurves$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(AR) rv $@ $(OBJS)
endif

$(EXTERNAL_LIBDIR)/libsfcurves$(shared_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(libmesh_CC) $(libmesh_CSHAREDFLAG) -o $@ $(OBJS) $(libmesh_LDFLAGS)


.PHONY: clean clobber distclean



clean:
	@rm -f $(OBJS) *~

clobber:
	@$(MAKE) clean
	@rm -f *.o *.g.o *.pg.o *.sy.o
	@rm -f $(EXTERNAL_LIBDIR)/libsfcurves.*

distclean:
	@$(MAKE) clobber
	@rm -f ../lib/*/libsfcurves.*

=== libmesh/contrib/tetgen/Makefile ===
# makefile for TetGen

include ../../Make.common

INCLUDE = -I.

# Package name and additional flags required for library compilation
pkgname  := tetgen
#libmesh_CXXFLAGS += -DTETLIBRARY
libmesh_CXXFLAGS := -DNDEBUG -DTETLIBRARY -fPIC

# (Relative) Path to location of shared libs
libpath := ../lib

SRC     := tetgen.C predicates.C
OBJS   	:= $(patsubst %.C, %.$(obj-suffix), $(SRC))


.PHONY: clean clobber distclean

target := $(EXTERNAL_LIBDIR)/lib$(pkgname)$(static_libext)

ifeq ($(enable-shared),yes)
  target := $(EXTERNAL_LIBDIR)/lib$(pkgname)$(shared_libext)
endif

ifeq ($(enable-tetgen),no)
  all::
	@echo "<<< $(pkgname) is disabled, not building >>>"
else
  all:: $(target)
endif


# Build static library
ifeq ($(findstring darwin,$(hostos)),darwin)
$(EXTERNAL_LIBDIR)/lib$(pkgname)$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@libtool -static -o $@ $(OBJS)
else
$(EXTERNAL_LIBDIR)/lib$(pkgname)$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(AR) rv $@ $(OBJS)
endif

# Build dynamic library
$(EXTERNAL_LIBDIR)/lib$(pkgname)$(shared_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(libmesh_CXX) $(libmesh_CXXSHAREDFLAG) -o $@ $(OBJS) $(libmesh_LDFLAGS)


clean:
	@rm -f $(OBJS) tetgen *~

clobber:
	@$(MAKE) clean
	@rm -f *.o *.g.o *.pg.o *.sy.o
	@rm -f $(EXTERNAL_LIBDIR)/lib$(pkgname).*

distclean:
	@$(MAKE) clobber
	@rm -f $(libpath)/*/lib$(pkgname).*

=== libmesh/contrib/triangle/Makefile ===
include ../../Make.common

INCLUDE = -I.

# Package name and additional flags required for library compilation
pkgname  := triangle
libmesh_CFLAGS   += -DTRILIBRARY -DANSI_DECLARATORS

# (Relative) Path to location of shared libs
libpath := ../lib

# Only one source file for triangle
SRC     := triangle.c
OBJS   	:= $(patsubst %.c, %.$(obj-suffix), $(SRC))


.PHONY: clean clobber distclean



target := $(EXTERNAL_LIBDIR)/lib$(pkgname)$(static_libext)

ifeq ($(enable-shared),yes)
  target := $(EXTERNAL_LIBDIR)/lib$(pkgname)$(shared_libext)
endif

ifeq ($(enable-triangle),no)
  all::
	@echo "<<< $(pkgname) is disabled, not building >>>"
else
  all:: $(target)
endif

# Build static library
ifeq ($(findstring darwin,$(hostos)),darwin)
$(EXTERNAL_LIBDIR)/lib$(pkgname)$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@libtool -static -o $@ $(OBJS)
else
$(EXTERNAL_LIBDIR)/lib$(pkgname)$(static_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(AR) rv $@ $(OBJS)
endif

# Build dynamic library
$(EXTERNAL_LIBDIR)/lib$(pkgname)$(shared_libext): $(OBJS)
	@echo "Linking "$@
	@$(shell mkdir -p $(EXTERNAL_LIBDIR))
	@$(libmesh_CC) $(libmesh_CSHAREDFLAG) -o $@ $(OBJS) $(libmesh_LDFLAGS)


clean:
	@rm -f $(OBJS) showme triangle tricall *~

clobber:
	@$(MAKE) clean
	@rm -f *.o *.g.o *.pg.o *.sy.o
	@rm -f $(EXTERNAL_LIBDIR)/lib$(pkgname).*

distclean:
	@$(MAKE) clobber
	@rm -f $(libpath)/*/lib$(pkgname).*

=== libmesh/examples/ex0/Makefile ===
# $Id: Makefile 4263 2011-03-14 18:38:12Z roystgnr $


# The location of the mesh library
LIBMESH_DIR ?= ../..

# include the library options determined by configure.  This will
# set the variables INCLUDE and LIBS that we will need to build and
# link with the library.
include $(LIBMESH_DIR)/Make.common


###############################################################################
# File management.  This is where the source, header, and object files are
# defined

#
# source files
srcfiles 	:= $(wildcard *.C)

#
# object files
objects		:= $(patsubst %.C, %.$(obj-suffix), $(srcfiles))
###############################################################################



.PHONY: clean clobber distclean

###############################################################################
# Target:
#
target 	   := ./ex0-$(METHOD)


all:: $(target)

# Production rules:  how to make the target
$(target): $(objects)
	@echo "Linking "$@"..."
	@$(libmesh_CXX) $(libmesh_CPPFLAGS) $(libmesh_CXXFLAGS) $(objects) -o $@ $(libmesh_LIBS) $(libmesh_LDFLAGS)


# Useful rules.
clean:
	@rm -f $(objects) *~

clobber:
	@$(MAKE) clean
	@rm -f $(target)

distclean:
	@$(MAKE) clobber
	@rm -f *.o *.g.o *.pg.o

run: $(target)
	@echo "***************************************************************"
	@echo "* Running Example " $(LIBMESH_RUN) $(target) $(LIBMESH_OPTIONS)
	@echo "***************************************************************"
	@echo " "
	@$(LIBMESH_RUN) $(target) $(LIBMESH_OPTIONS)
	@echo " "
	@echo "***************************************************************"
	@echo "* Done Running Example " $(LIBMESH_RUN) $(target) $(LIBMESH_OPTIONS)
	@echo "***************************************************************"


# include the dependency list
include .depend


#
# Dependencies
#
.depend:
	@$(perl) $(LIBMESH_DIR)/contrib/bin/make_dependencies.pl -I. $(foreach i, $(wildcard $(LIBMESH_DIR)/include/*), -I$(i)) "-S\$$(obj-suffix)" $(srcfiles) > .depend

###############################################################################

=== libmesh/examples/ex1/Makefile ===
# $Id: Makefile 4393 2011-04-22 00:20:06Z roystgnr $


# The location of the mesh library
LIBMESH_DIR ?= ../..

# include the library options determined by configure.  This will
# set the variables INCLUDE and LIBS that we will need to build and
# link with the library.
include $(LIBMESH_DIR)/Make.common


###############################################################################
# File management.  This is where the source, header, and object files are
# defined

#
# source files
srcfiles 	:= $(wildcard *.C)

#
# object files
objects		:= $(patsubst %.C, %.$(obj-suffix), $(srcfiles))
###############################################################################



.PHONY: clean clobber distclean

###############################################################################
# Target:
#
target 	   := ./ex1-$(METHOD)


all:: $(target)

# Production rules:  how to make the target
$(target): $(objects)
	@echo "Linking "$@"..."
	@$(libmesh_CXX) $(libmesh_CPPFLAGS) $(libmesh_CXXFLAGS) $(objects) -o $@ $(libmesh_LIBS) $(libmesh_LDFLAGS)


# Useful rules.
clean:
	@rm -f $(objects) *~

clobber:
	@$(MAKE) clean
	@rm -f $(target)

distclean:
	@$(MAKE) clobber
	@rm -f *.o *.g.o *.pg.o

run: $(target)
	@echo "***************************************************************"
	@echo "* Running Example " $(LIBMESH_RUN) $(target) -d 3 $(LIBMESH_DIR)/reference_elements/3D/one_hex27.xda [-o output.xda] $(LIBMESH_OPTIONS)
	@echo "***************************************************************"
	@echo " "
	@$(LIBMESH_RUN) $(target) -d 3 $(LIBMESH_DIR)/reference_elements/3D/one_hex27.xda $(LIBMESH_OPTIONS)
	@$(LIBMESH_RUN) $(target) -d 3 $(LIBMESH_DIR)/reference_elements/3D/one_hex27.xda -o output.xda $(LIBMESH_OPTIONS)
	@echo " "
	@echo "***************************************************************"
	@echo "* Done Running Example " $(LIBMESH_RUN) $(target) -d 3 $(LIBMESH_DIR)/reference_elements/3D/one_hex27.xda [-o output.xda] $(LIBMESH_OPTIONS)
	@echo "***************************************************************"


# include the dependency list
include .depend


#
# Dependencies
#
.depend:
	@$(perl) $(LIBMESH_DIR)/contrib/bin/make_dependencies.pl -I. $(foreach i, $(wildcard $(LIBMESH_DIR)/include/*), -I$(i)) "-S\$$(obj-suffix)" $(srcfiles) > .depend

###############################################################################

=== libmesh/examples/ex10/Makefile ===
# $Id: Makefile 4263 2011-03-14 18:38:12Z roystgnr $


# The location of the mesh library
LIBMESH_DIR ?= ../..

# include the library options determined by configure.  This will
# set the variables INCLUDE and LIBS that we will need to build and
# link with the library.
include $(LIBMESH_DIR)/Make.common


###############################################################################
# File management.  This is where the source, header, and object files are
# defined

#
# source files
srcfiles 	:= $(wildcard *.C) ../ex9/exact_solution.C

#
# object files
objects		:= $(patsubst %.C, %.$(obj-suffix), $(srcfiles))
###############################################################################



.PHONY: clean clobber distclean

###############################################################################
# Target:
#
target 	      := ./ex10-$(METHOD)

# Specify the number of timesteps to do when we call "make run"
n_timesteps   := 25

# Specify the amount of initial uniform refinement to do
n_refinements := 5

# Specify how often to write output files
output_freq   := 10

all:: $(target)

# Production rules:  how to make the target - depends on library configuration
$(target): $(objects)
	@echo "Linking "$@"..."
	@$(libmesh_CXX) $(libmesh_CPPFLAGS) $(libmesh_CXXFLAGS) $(objects) -o $@ $(libmesh_LIBS) $(libmesh_LDFLAGS)

# Useful rules.
clean:
	@rm -f $(objects) *~

clobber:
	@$(MAKE) clean
	@rm -f $(target) out_*.gmv

distclean:
	@$(MAKE) clobber
	@rm -f *.o *.g.o *.pg.o


run: $(target)
	@echo "***************************************************************"
	@echo "* Running Example " $(LIBMESH_RUN) $(target) \[-read_solution\] -n_timesteps $(n_timesteps) -n_refinements $(n_refinements) -init_timestep \[0\|$(n_timesteps)\] $(LIBMESH_OPTIONS)
	@echo "***************************************************************"
	@echo " "
	@$(LIBMESH_RUN) $(target) -n_timesteps $(n_timesteps) -n_refinements $(n_refinements) \
                   -output_freq $(output_freq) -init_timestep 0 $(LIBMESH_OPTIONS)
	@echo " "
	@echo "***** Finished first" $(n_timesteps) "steps, now read in" \
	       "saved solution and continue *****"
	@echo " "
	@$(LIBMESH_RUN) $(target) -read_solution -n_timesteps $(n_timesteps) \
                   -output_freq $(output_freq) -init_timestep $(n_timesteps) $(LIBMESH_OPTIONS)
	@echo " "
	@echo "***************************************************************"
	@echo "* Done Running Example " $(LIBMESH_RUN) $(target) \[-read_solution\] -n_timesteps $(n_timesteps) -init_timestep \[0\|$(n_timesteps)\] $(LIBMESH_OPTIONS)
	@echo "***************************************************************"


restart: $(target)
	@echo "***************************************************************"
	@echo "* Restarting Example " $(target)
	@echo "***************************************************************"
	@echo " "
	@echo "***** Read in saved solution and continue *****"
	@echo " "
	@$(LIBMESH_RUN) $(target) -read_solution -n_timesteps $(n_timesteps) \
                   -output_freq $(output_freq) -init_timestep $(n_timesteps) $(LIBMESH_OPTIONS)
	@echo " "
	@echo "***************************************************************"
	@echo "* Done Restarting Example " $(target)
	@echo "***************************************************************"


# include the dependency list
include .depend


#
# Dependencies
#
.depend:
	@$(perl) $(LIBMESH_DIR)/contrib/bin/make_dependencies.pl -I. $(foreach i, $(wildcard $(LIBMESH_DIR)/include/*), -I$(i)) "-S\$$(obj-suffix)" $(srcfiles) > .depend

###############################################################################

=== debian/changelog ===
libmesh (0.7.1-2ubuntu1) precise; urgency=low

  * Remove hardcoded reference to vtk5.6 in debian/rules

 -- Andreas Moog <amoog@ubuntu.com>  Mon, 26 Dec 2011 10:59:10 +0100

libmesh (0.7.1-2build1) precise; urgency=low

  * Rebuild for libvtk transition

 -- Andreas Moog <amoog@ubuntu.com>  Sun, 25 Dec 2011 23:45:09 +0100

libmesh (0.7.1-2) unstable; urgency=low

  * Team upload
  * libmesh-dev: libpetsc3.1-dev & libslepc3.1-dev dependencies updates (thanks
    to Stefano Rivera for pointing this issue.
  * Replace linux-gnu-c-opt to $(shell petscarch) in the PETSC_ARCH= declaration

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 11 Aug 2011 15:53:02 +0200

libmesh (0.7.1-1) unstable; urgency=low

  * Team upload
  * New upstream release
    - Use a more recent version of vtk (Closes: #577584)
  * Update the dependency on libpetsc (Closes: #618233)
  * doxygen-latex replaces doxygen and texlive-* dep (Closes: #616258)
  * Standards-Version updated to version 3.9.2
  * Package moved to Debian Science
  * mpi-default-dev added a build dep (Closes: #576969)
  * Switch to dpkg-source 3.0 (quilt) format
  * old-fsf-address-in-copyright-file fixed
  * debhelper-but-no-misc-depends fixed
  * debian-rules-missing-recommended-target fixed

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 02 Aug 2011 14:46:47 +0200

libmesh (0.6.4.dfsg-1) unstable; urgency=low

  * New upstream (closes: #496143).
  * Added libmesh-doc package with doxygen-generated .php documentation files
    (closes: #496139).
  * I think docs require a PHP-capable web server, so I have dwww and the
    Apache PHP module in Suggests.
  * Added README.source.
  * Bumped Standards-Version.
  * Changed petsc dependencies from 2.3.3 to 3.0.0 (closes: #529477, #534057).
  * Uses new copyright format.
  * Included QPL in copyright (closes: #513814).
  * Removed Ondrej Certik from Uploaders list (closes: #550413).
  * Added SLEPc support (closes: #491382).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 11 Nov 2009 14:34:41 -0500

libmesh (0.6.3.dfsg~rc1-1) unstable; urgency=low

  * New upstream release candidate.
  * Fixes slow matrix insertion (closes: #).
  * Package reorg: removed -pure packages, renamed 0.6.3-dev to -dev because
    there's no way to install multiple -dev packages simultaneously.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Fri, 22 Aug 2008 14:02:08 -0400

libmesh (0.6.2.dfsg-2) unstable; urgency=low

  * Completed scotch shared lib transition (closes: #470418).
  * Added conflicts to -dev packages (closes: #486706, #486708).
  * Added --enable-perflog to configure lines (closes: #491379).
  * Added VTK support (closes: #491380).
  * Added working example makefiles, and modified README.Debian
    (closes: #491381).
  * Added infinite finite element support (closes: #491744).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 22 Jul 2008 08:12:30 -0400

libmesh (0.6.2.dfsg-1) unstable; urgency=low

  * Added Adam Powell to Uploaders.
  * Upload of unreleased fixes (closes: #450500, #455670, #468550)
  * Turned on --enable-metis to use scotch metis compatibility.
  * Removed petscts libs from LDFLAGS because libmesh doesn't use it.
  * Removed a bunch of conflicts: only the -dev packages conflict with each
    other.
  * Changed -dev packages to arch all because they are.
  * Edited README.Debian removing petsc libraries from example link command
    because they're linked from libmesh (scotch too when 470422 is fixed).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 11 Jun 2008 09:11:27 -0400

libmesh (0.6.2.dfsg-0.1) UNRELEASED; urgency=low

  * Non Maintainer Upload.
  * New upstream release (Closes: #450500)
  * Added second derivative support, passing --enable-second to the configure
    call (Closes: #468550)
  * Added support for scotchmetis with scotchmetis_support.patch.
  * Disabled metis, exodus and netcdf support, due to them needing libraries
    that weren't being installed.
  * Fixed gcc-4.3 issues with gcc-4.3_support.patch (Closes: #455670)
  * Modified dfsg version so it does clean nicely.

 -- Maximiliano Curia <maxy@gnuservers.com.ar>  Wed, 26 Mar 2008 21:56:46 -0300

libmesh (0.6.1.dfsg-3) unstable; urgency=low

  * Patches moved under the quilt control
  * Homepage moved to the Homepage field
  * Standards-Version bumped to 3.7.3

 -- Ondrej Certik <ondrej@certik.cz>  Sat, 16 Feb 2008 14:07:56 +0100

libmesh (0.6.1.dfsg-2) unstable; urgency=low

  * Rebuild against latest openmpi, that works

 -- Ondrej Certik <ondrej@certik.cz>  Sat, 15 Dec 2007 13:50:16 +0100

libmesh (0.6.1.dfsg-1) unstable; urgency=low

  [Ondrej Certik]
  * New upstream version
  * Ondrej Certik and Alan Woodland added to Uploaders.
  * Patch applied, so that libmesh-pure works with ExplicitSystem

  [ Christophe Prud'homme ]
  * debian/control: set XS-DM-Upload-Allowed to yes
 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 30 Nov 2007 11:09:35 +0100

libmesh (0.6.0~rc2.dfsg-3) unstable; urgency=low

  [Ondrej Certik]
  * Built against libpetsc2.3.3, which is now in Debian (Closes: #435532)
  
  [ Christophe Prud'homme ]
  * debian/control: modified maintainer and uploader fields

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 03 Sep 2007 22:11:32 +0200

libmesh (0.6.0~rc2.dfsg-2oc1) unstable; urgency=low

  * Build against libpetsc2.3.3

 -- Ondrej Certik <ondrej@certik.cz>  Sun, 22 Jul 2007 16:26:55 +0200

libmesh (0.6.0~rc2.dfsg-2) unstable; urgency=low

  * Upload of unofficial revisions 1oc1, 1oc2, 1oc3 into Debian

 -- Ondrej Certik <ondrej@certik.cz>  Fri, 13 Jul 2007 12:15:25 +0200

libmesh (0.6.0~rc2.dfsg-1oc3) unstable; urgency=low

  * Build two libraries - one with petsc, the other without (libmesh0.6.0-pure)

 -- Ondrej Certik <ondrej@certik.cz>  Sat, 07 Jul 2007 19:42:14 +0200

libmesh (0.6.0~rc2.dfsg-1oc2) unstable; urgency=low

  * build without petsc

 -- Ondrej Certik <ondrej@certik.cz>  Sat, 07 Jul 2007 17:49:12 +0200

libmesh (0.6.0~rc2.dfsg-1oc1) unstable; urgency=low



=== debian/control ===
Source: libmesh
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer:  Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>, Christophe Prud'homme <prudhomm@debian.org>, Alan Woodland <ajw05@aber.ac.uk>
XS-DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 5), quilt, autotools-dev (>= 20070306.1), autoconf,
 libpetsc3.1-dev, libslepc3.1-dev, libscotchmetis-dev (>= 5.0.6-2),
 libblas-dev | libblas-3gf.so, libnetcdf-dev, libtbb-dev, libvtk5-dev, libtool,
 automake, mpi-default-dev, enscript
Build-Depends-Indep: graphviz, doxygen-latex
Standards-Version: 3.9.2
Section: libs
Homepage: http://libmesh.sourceforge.net/

Package: libmesh-dev
Section: libdevel
Architecture: all
Depends: libmesh0.7.1 (>= ${binary:Version}), libpetsc3.1-dev, libslepc3.1-dev,
 libscotchmetis-dev (>= 5.0.6-2), libblas-dev | libblas-3gf.so, libnetcdf-dev,
 libtbb-dev, libvtk5-dev, ${misc:Depends} 
Conflicts: libmesh0.6.1-dev, libmesh0.6.1-pure-dev, libmesh0.6.2-dev, libmesh0.6.2-pure-dev
Replaces: libmesh0.6.1-dev, libmesh0.6.1-pure-dev, libmesh0.6.2-dev, libmesh0.6.2-pure-dev
Suggests: libmesh-doc
Description: libMesh - A C++ Finite Element Library
 The libMesh library is a C++ framework for the numerical simulation of partial
 differential equations on serial and parallel platforms. Development began in
 March 2002 with the intent of providing a friendly interface to a number of
 high-quality software packages that are publicly available. Currently the
 library supports 1D, 2D, and 3D steady and transient finite element and finite
 volume simulations. PETSc is currently used for the solution of linear systems
 on both serial and parallel platforms.
 .
 This package contains the C++ header files and shared library links (only
 needed for developing programs with libmesh).

Package: libmesh0.7.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libmesh0.6.4
Replaces: libmesh0.6.4
Description: libMesh - A C++ Finite Element Library
 The libMesh library is a C++ framework for the numerical simulation of partial
 differential equations on serial and parallel platforms. Development began in
 March 2002 with the intent of providing a friendly interface to a number of
 high-quality software packages that are publicly available. Currently the
 library supports 1D, 2D, and 3D steady and transient finite element and finite
 volume simulations. PETSc is currently used for the solution of linear systems
 on both serial and parallel platforms.
 .
 This package contains the libMesh shared library.

Package: libmesh-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libmesh-dev (>= ${source:Version}), dwww, libapache-mod-php5 | libapache2-mod-php5
Description: libMesh - A C++ Finite Element Library
 The libMesh library is a C++ framework for the numerical simulation of partial
 differential equations on serial and parallel platforms. Development began in
 March 2002 with the intent of providing a friendly interface to a number of
 high-quality software packages that are publicly available. Currently the
 library supports 1D, 2D, and 3D steady and transient finite element and finite
 volume simulations. PETSc is currently used for the solution of linear systems
 on both serial and parallel platforms.
 .
 This package contains the class documentation, manual pages and examples; much
 of the documentation is in PHP format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
LIBMESH_VERSION=0.7.1

# shared library versions, option 1
version=2.0.5
major=2

libmesh/config.status: libmesh/configure.in
	dh_testdir
	cp /usr/share/misc/config.guess libmesh/
	cp /usr/share/misc/config.sub libmesh/
	QUILT_PATCHES=debian/patches quilt push -a || test $$? = 2
	cd libmesh && libtoolize && autoreconf -I m4/
	cd libmesh && PETSC_DIR=/usr/lib/petsc PETSC_ARCH=$(shell petscarch) \
	  SLEPC_DIR=/usr/lib/slepc \
	  LDFLAGS=-Wl,-soname,libmesh.so.$(LIBMESH_VERSION),-lpetsc,-lpetscdm,-lpetscksp,-lpetscmat,-lpetscsnes,-lpetscvec,-lscotchmetis,-lblas,-ltbb,-ltbbmalloc,-lvtkIO,-lvtkCommon,-lvtkFiltering \
	  ./configure --prefix=/usr \
	   --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
	   --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info \
	   --disable-laspack --disable-sfc --disable-gzstreams --disable-gmv \
	   --disable-tecplot --disable-parmetis --disable-tetgen \
	   --disable-triangle --disable-exodus --disable-libHilbert \
	   --with-mpi=/usr --with-cxx=mpicxx --with-cc=mpicc --with-f77=mpif77\
	   --enable-second --enable-ifem --enable-metis --enable-perflog \
	   --enable-vtk --with-vtk-include=/usr/include/vtk-5.8 --with-tbb=/usr

build: build-arch
build-arch: libmesh/config.status
	dh_testdir
	$(MAKE) -C libmesh
	touch $@

build-indep: libmesh/config.status
	dh_testdir
	$(MAKE) -C libmesh doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch
	QUILT_PATCHES=debian/patches quilt pop -a -R || test $$? = 2

	[ ! -f libmesh/Make.common ] || $(MAKE) -C libmesh distclean
	rm -f libmesh/config.sub libmesh/config.guess libmesh/config.log
	find -type f -name '.*' -exec '{}' ';'

	dh_clean

meshlib = $(CURDIR)/debian/libmesh$(LIBMESH_VERSION)
meshdev = $(CURDIR)/debian/libmesh-dev

install: install-stamp
install-stamp: build
	dh_testdir
	dh_testroot
	dh_clean
	dh_installdirs

	mkdir -p $(meshlib)/usr/lib
	mkdir -p $(meshdev)/usr/lib
	libdir=`grep "hosttype " libmesh/Make.common | cut -d "=" -f 2 | cut -c 2-`; \
	cp libmesh/lib/$${libdir}_opt/libmesh.so $(meshlib)/usr/lib/libmesh.so.$(LIBMESH_VERSION)
	ln -s libmesh.so.$(LIBMESH_VERSION) $(meshdev)/usr/lib/libmesh.so
	mkdir -p $(meshdev)/usr/include/libmesh
	cp libmesh/include/base/* libmesh/include/enums/* libmesh/include/error_estimation/* libmesh/include/fe/* libmesh/include/geom/* libmesh/include/mesh/* libmesh/include/numerics/* libmesh/include/parallel/* libmesh/include/partitioning/* libmesh/include/quadrature/* libmesh/include/solvers/* libmesh/include/utils/* $(meshdev)/usr/include/libmesh
	rm $(meshdev)/usr/include/libmesh/libmesh_config.h.in
	-rm $(meshdev)/usr/include/libmesh/libmesh_contrib_config.h.in
	touch $@

# Build architecture-independent files here.
binary-indep: build-indep install-stamp
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i libmesh/CHANGES
	dh_installdocs -i
	mv debian/libmesh-doc/usr/share/doc/libmesh-doc/man \
	  debian/libmesh-doc/usr/share/
	mv debian/libmesh-doc/usr/share/doc/libmesh-doc/latex/*/*.pdf \
	  debian/libmesh-doc/usr/share/doc/libmesh-doc/
	rm -rf debian/libmesh-doc/usr/share/doc/libmesh-doc/latex \
	  debian/libmesh-doc/usr/share/doc/libmesh-doc/Doxyfile* \
	  debian/libmesh-doc/usr/share/doc/libmesh-doc/dot*
	dh_installexamples -i "--exclude=.depend"
	for exmake in `ls debian/exmake/Makefile.ex* | sed 's/debian\/exmake\/Makefile.//'`; do \
	  cp -f debian/exmake/Makefile.$$exmake \
	    $(CURDIR)/debian/libmesh-doc/usr/share/doc/libmesh-doc/examples/$$exmake/Makefile; \
	done
	dh_compress -i -X.php -X.js -X.pdf
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install-stamp
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a libmesh/CHANGES
	dh_installdocs -a
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -av
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install 

get-orig-source:
	wget http://qa.debian.org/watch/sf.php/libmesh/libmesh-0.6.4.tar.gz
	tar xzf libmesh-0.6.4.tar.gz
	rm -r libmesh-0.6.4/libmesh/contrib/laspack
	rm -r libmesh-0.6.4/libmesh/contrib/metis
	rm -r libmesh-0.6.4/libmesh/contrib/parmetis
	rm -r libmesh-0.6.4/libmesh/contrib/sfcurves
	rm -r libmesh-0.6.4/libmesh/contrib/tecplot
	rm -r libmesh-0.6.4/libmesh/contrib/tetgen
	rm -r libmesh-0.6.4/libmesh/contrib/triangle
	find libmesh-0.6.4 -type f -name '.*' -exec rm '{}' ';'
	mv libmesh-0.6.4 libmesh-0.6.4.dfsg
	tar czf libmesh_0.6.4.dfsg.orig.tar.gz libmesh-0.6.4.dfsg
	rm -r libmesh-0.6.4.dfsg libmesh-0.6.4.tar.gz

=== debian/watch ===
version=3
opts=dversionmangle=s/\.dfsg.*$//,uversionmangle=s/-(rc\d+)/~$1/ \
 http://sf.net/libmesh/libmesh-([\d\.rc-]+)\.tar\.gz
